unit mainform;

{

 VL:
Copyright (C) 2017  . .

   .

}

interface

uses
 Windows,SysUtils,Classes,Controls,Forms,Dialogs,StdCtrls,ExtCtrls;

type

 //    
 TMain_Form = class (TForm)
               FileName_Edit  : TLabeledEdit;
               Browse_Button  : TButton;
               Start_Button   : TButton;
               OpenDialog     : TOpenDialog;
               Label1         : TLabel;
               Label2         : TLabel;
               Version_Label  : TLabel;
               Debug_Label    : TLabel;
               Site_Label     : TLabel;
               ProtType_Group : TRadioGroup;
    Label3: TLabel;
               procedure Browse_ButtonClick (Sender: TObject);
               procedure Start_ButtonClick (Sender: TObject);
               procedure OnShow (Sender: TObject);
               procedure Site_LabelClick (Sender: TObject);
               procedure OnClose (Sender: TObject; var Action: TCloseAction);
              private
               { Private declarations }
              public
               { Public declarations }
              end;

var

 //   
 Main_Form: TMain_Form;

implementation

{$R *.dfm}

uses prot501,rsvnalog,xmlwork,ShellAPI,constants,stringfuncs,config;

var

 Conf : TAppConfig; //   

//     ""
procedure TMain_Form.Browse_ButtonClick (Sender: TObject);
begin
 OpenDialog.FileName := FileName_Edit.Text;
 if OpenDialog.Execute then FileName_Edit.Text := OpenDialog.FileName;
end;

//  OnClose  
procedure TMain_Form.OnClose(Sender: TObject; var Action: TCloseAction);
begin
 //         
 Conf.LastCheckedFile := FileName_Edit.Text;
 Conf.ProtType := ProtType_Group.ItemIndex;
 Conf.Write;
end;

//  OnShow  
procedure TMain_Form.OnShow (Sender: TObject);
begin
 //    
 Debug_Label.Visible := DebugBuild;
 Version_Label.Caption := ' ' + ProgramVersion + '  ' + DateVersion;
 //        
 Conf.Read;
 FileName_Edit.Text := Conf.LastCheckedFile;
 ProtType_Group.ItemIndex := Conf.ProtType;
end;

//    " "
procedure TMain_Form.Site_LabelClick (Sender: TObject);
var
 s : string;
begin
 s := ProgramSite;
 ShellExecute (Handle,'open',PChar (s),'','',SW_MAXIMIZE);
end;

//    ""
procedure TMain_Form.Start_ButtonClick (Sender: TObject);
var
 RSVFile      : TRSVFile;      //     
 Prot501      : TRSV501Prot;   //  
 XML          : TXMLFile;      //  xml-    
 ProtFileName : string;        //   
 s            : ANSIString;    //   
 i            : integer;       //   

begin
 //    
 if not FileExists (FileName_Edit.Text) then ShowMessage ('    .')
 else begin
       //   xml-  
       XML := TXMLFile.Create;
       //  xml-
       if not XML.ReadFromFile (FileName_Edit.Text) then ShowMessage ('   .')
       //   xml-
       else if not XML.Parse then ShowMessage ('   XML-.')
       // ,  xml-   
       else if XML.Tag.Name <> '' then ShowMessage ('     .')
       else begin
             //      
             RSVFile := TRSVFile.Create;
             //    xml-
             RSVFile.Read (XML.Tag,'');
             //   
             Prot501 := TRSV501Prot.Create;
             //      
             if not Prot501.Fill (RSVFile,ExtractFilePath (FileName_Edit.Text)) then ShowMessage (Prot501.ErrorMsg)
             else begin
                   //        ;       
                   ProtFileName := ExtractFileName (FileName_Edit.Text);
                   ProtFileName := Copy (ProtFileName,1,Length (ProtFileName) - 4);
                   s := Prot501.CheckDateTime;
                   s := str_replace (s,':','-',i);
                   s := str_replace (s,' ','_',i);
                   ProtFileName := 'prot_' + s + '_' + ProtFileName;
                   //       ,        
                   if ProtType_Group.ItemIndex = 2
                    then begin
                          //  html-      
                          ProtFileName := GetEnvironmentVariable ('TEMP') + '\' + ProtFileName + '.html';
                          Prot501.SaveHTML (ProtFileName);
                          ShellExecute (Handle,'open',PChar (ProtFileName),'','',SW_MAXIMIZE);
                         end
                    else begin
                          //     XML Spreadsheet
                          ProtFileName := GetEnvironmentVariable ('TEMP') + '\' + ProtFileName + '.xml';
                          Prot501.SaveExcel (ProtFileName);
                          //    Excel  OpenOffice
                          if ProtType_Group.ItemIndex = 0 then ShellExecute (Handle,'open','excel.exe',PChar (ProtFileName),'',SW_MAXIMIZE)
                          else ShellExecute (Handle,'open','scalc.exe',PChar (ProtFileName),'',SW_MAXIMIZE);
                         end;
                  end;
             //     
             Prot501.Free;
             RSVFile.Free;
            end;
       //   xml-
       XML.Free;
      end;
end;

end.
