unit format5;

{

   5  
Copyright (c) 2017  . .

}

interface

uses xmlwork;

type

 // ,  
 TUdLichn = class
             DocVid  : ANSIString;
             SerNum  : ANSIString;
             KemVyd  : ANSIString;
             DateVyd : ANSIString;
             constructor Create;
             destructor Destroy;
            private
             procedure Init;
             procedure AddError (Msg : ANSIString);
             procedure AddWarning (Msg : ANSIString);
            public
             Errors : array of ANSIString;
             Warnings : array of ANSIString;
             function Read (XML : TXMLElement; Path : ANSIString) : Boolean;         
            end;

 // 
 TAddrRF = class
            PIndex : ANSIString;
            RegionCode : ANSIString;
            District : ANSIString;
            City : ANSIString;
            Town : ANSIString;
            Street : ANSIString;
            House : ANSIString;
            Corpus : ANSIString;
            Quart : ANSIString;
            constructor Create;
            destructor Destroy;
           private
            procedure Init;
            procedure AddError (Msg : ANSIString);
            procedure AddWarning (Msg : ANSIString);
           public
            Errors : array of ANSIString;
            Warnings : array of ANSIString;
            function Read (XML : TXMLElement; Path : ANSIString) : Boolean;         
           end;

 // 
 TFIO = class
         SurName    : ANSIString; // 
         Name       : ANSIString; // 
         FatherName : ANSIString; // 
         constructor Create;
         destructor Destroy;
        private
         procedure Init;
         procedure AddError (Msg : ANSIString);
         procedure AddWarning (Msg : ANSIString);
        public
         Errors : array of ANSIString;
         Warnings : array of ANSIString;
         function Read (XML : TXMLElement; Path : ANSIString) : Boolean;         
        end;

 //    
 TOrgUL = class
           OrgName   : ANSIString;  //  - (1-1000)
           INNUL     : ANSIString;  // 
           KPP       : ANSIString;  // 
           ReorgForm : ANSIString; //   
           ReorgINN  : ANSIString; //   
           ReorgKPP  : ANSIString; //   
           constructor Create;
           destructor Destroy;
          private
           procedure Init;
           procedure AddError (Msg : ANSIString);
           procedure AddWarning (Msg : ANSIString);
          public
           Errors : array of ANSIString;
           Warnings : array of ANSIString;
           function Read (XML : TXMLElement; Path : ANSIString) : Boolean;
          end;

 //    ,  
 TOrgIP = class
           INNPL      : ANSIString;  // 
           FIO        : TFIO;        // 
           constructor Create;
           destructor Destroy;
          private
           procedure Init;
           procedure AddError (Msg : ANSIString);
           procedure AddWarning (Msg : ANSIString);
          public
           Errors : array of ANSIString;
           Warnings : array of ANSIString;
           function Read (XML : TXMLElement; Path : ANSIString) : Boolean;
          end;

 //   ,   
 TSvedPL = class
           BirthDate  : ANSIString;
           BirthPlace : ANSIString;
           Citizenship : ANSIString;
           UdLichn     : TUdLichn;
           AddrRF      : TAddrRF;
           constructor Create;
           destructor Destroy;
          private
           procedure Init;
           procedure AddError (Msg : ANSIString);
           procedure AddWarning (Msg : ANSIString);
          public
           Errors : array of ANSIString;
           Warnings : array of ANSIString;
           function Read (XML : TXMLElement; Path : ANSIString) : Boolean;
          end;

 //   - ,   
 TOrgPL = class
           SvedPL : TSvedPL;
           FIO    : TFIO;
           INNFL  : ANSIString;
           constructor Create;
           destructor Destroy;
          private
           procedure Init;
           procedure AddError (Msg : ANSIString);
           procedure AddWarning (Msg : ANSIString);
          public
           Errors : array of ANSIString;
           Warnings : array of ANSIString;
           function Read (XML : TXMLElement; Path : ANSIString) : Boolean;
          end;





 //    
 TSvPred = class
            DocName : ANSIString;
            OrgName : ANSIString;
            constructor Create;
            destructor Destroy;
           private
            procedure Init;
            procedure AddError (Msg : ANSIString);
            procedure AddWarning (Msg : ANSIString);
           public
            Errors : array of ANSIString;
            Warnings : array of ANSIString;
            function Read (XML : TXMLElement; Path : ANSIString) : Boolean;
           end;

 // 
 TPodpisant = class
               PrPodp : integer;    //  
               FIO    : TFIO;       //  
               SvPred : TSvPred;    //     
               constructor Create;
               destructor Destroy;
              private
               procedure Init;
               procedure AddError (Msg : ANSIString);
               procedure AddWarning (Msg : ANSIString);
              public
               Errors : array of ANSIString;
               Warnings : array of ANSIString;
               function Read (XML : TXMLElement; Path : ANSIString) : Boolean;
              end;
  
implementation

uses stringfuncs,SysUtils;

constructor TUdLichn.Create;
begin
 Init;
end;

destructor TUdLichn.Destroy;
begin
 Init;
 inherited Destroy;
end;

procedure TUdLichn.Init;
begin
 DocVid := '';
 SerNum  := '';
 KemVyd  := '';
 DateVyd := '';
 SetLength (Errors,0);
 SetLength (Warnings,0);
end;

procedure TUdLichn.AddError (Msg : ANSIString);
begin
 SetLength (Errors,Length (Errors) + 1);
 Errors [Length (Errors) - 1] := Msg;
end;

procedure TUdLichn.AddWarning (Msg : ANSIString);
begin
 SetLength (Warnings,Length (Warnings) + 1);
 Warnings [Length (Warnings) - 1] := Msg;
end;

function TUdLichn.Read (XML : TXMLElement; Path : ANSIString) : Boolean;
var
 i : integer;
begin
 Init;
 if Length (XML.Attrs) = 0
  then AddError (Path + ':   "  ,  "  .')
 else for i := 0 to Length (XML.Attrs) - 1
  do if XML.Attrs [i].Name = '' then DocVid := htmlspecialchars_decode (XML.Attrs [i].Value)
  else if XML.Attrs [i].Name = '' then SerNum := htmlspecialchars_decode (XML.Attrs [i].Value)
  else if XML.Attrs [i].Name = '' then KemVyd := htmlspecialchars_decode (XML.Attrs [i].Value)
  else if XML.Attrs [i].Name = '' then DateVyd := htmlspecialchars_decode (XML.Attrs [i].Value)
  else AddError (Path + ':     "' + XML.Attrs [i].Name + '"   "  ,  "');
 if Length (XML.Child) > 0
  then AddError (Path + ':   "  ,  "   ,   .');
 Result := (Length (Errors) = 0);
end;

constructor TAddrRF.Create;
begin
 Init;
end;

destructor TAddrRF.Destroy;
begin
 Init;
 inherited Destroy;
end;

procedure TAddrRF.Init;
begin
 PIndex := '';
 RegionCode := '';
 District := '';
 City := '';
 Town := '';
 Street := '';
 House := '';
 Corpus := '';
 Quart := '';
 SetLength (Errors,0);
 SetLength (Warnings,0);
end;

procedure TAddrRF.AddError (Msg : ANSIString);
begin
 SetLength (Errors,Length (Errors) + 1);
 Errors [Length (Errors) - 1] := Msg;
end;

procedure TAddrRF.AddWarning (Msg : ANSIString);
begin
 SetLength (Warnings,Length (Warnings) + 1);
 Warnings [Length (Warnings) - 1] := Msg;
end;

function TAddrRF.Read (XML : TXMLElement; Path : ANSIString) : Boolean;
var
 i : integer;
begin
 Init;
 if Length (XML.Attrs) = 0
  then AddError (Path + ':   "   "  .')
 else for i := 0 to Length (XML.Attrs) - 1
  do if XML.Attrs [i].Name = '' then PIndex := htmlspecialchars_decode (XML.Attrs [i].Value)
  else if XML.Attrs [i].Name = '' then RegionCode := htmlspecialchars_decode (XML.Attrs [i].Value)
  else if XML.Attrs [i].Name = '' then District := htmlspecialchars_decode (XML.Attrs [i].Value)
  else if XML.Attrs [i].Name = '' then City := htmlspecialchars_decode (XML.Attrs [i].Value)
  else if XML.Attrs [i].Name = '' then Town := htmlspecialchars_decode (XML.Attrs [i].Value)
  else if XML.Attrs [i].Name = '' then Street := htmlspecialchars_decode (XML.Attrs [i].Value)
  else if XML.Attrs [i].Name = '' then House := htmlspecialchars_decode (XML.Attrs [i].Value)
  else if XML.Attrs [i].Name = '' then Corpus := htmlspecialchars_decode (XML.Attrs [i].Value)
  else if XML.Attrs [i].Name = '' then Quart := htmlspecialchars_decode (XML.Attrs [i].Value)
  else AddError (Path + ':     "' + XML.Attrs [i].Name + '"   "   "');
 if Length (XML.Child) > 0
  then AddError (Path + ':   "   "   ,   .');
 Result := (Length (Errors) = 0);
end;

constructor TOrgUL.Create;
begin
 Init;
end;

destructor TOrgUL.Destroy;
begin
 Init;
 inherited Destroy;
end;

procedure TOrgUL.Init;
begin
 OrgName := '';
 INNUL := '';
 KPP := '';
 ReorgForm := '';
 ReorgINN := '';
 ReorgKPP := '';
 SetLength (Errors,0);
 SetLength (Warnings,0);
end;

procedure TOrgUL.AddError (Msg : ANSIString);
begin
 SetLength (Errors,Length (Errors) + 1);
 Errors [Length (Errors) - 1] := Msg;
end;

procedure TOrgUL.AddWarning (Msg : ANSIString);
begin
 SetLength (Warnings,Length (Warnings) + 1);
 Warnings [Length (Warnings) - 1] := Msg;
end;

function TOrgUL.Read (XML : TXMLElement; Path : ANSIString) : Boolean;
var
 i,j : integer;
begin
 Init;
 if Length (XML.Attrs) <> 3
  then AddError (Path + ':   "   "    3 .')
 else for i := 0 to 2
  do if XML.Attrs [i].Name = '' then OrgName := htmlspecialchars_decode (XML.Attrs [i].Value)
  else if XML.Attrs [i].Name = '' then INNUL := htmlspecialchars_decode (XML.Attrs [i].Value)
  else if XML.Attrs [i].Name = '' then KPP := htmlspecialchars_decode (XML.Attrs [i].Value)
  else AddError (Path + ':     "' + XML.Attrs [i].Name + '"   "   "');
 if Length (XML.Child) > 0
  then for i := 0 to Length (XML.Child) - 1
   do if XML.Child [i].Name = ''
    then begin
          if (Length (XML.Child [i].Attrs) <> 3) and (Length (XML.Child [i].Attrs) <> 1) then AddError (Path + ' - :  "   () "   1  3 .')
          else begin
                for j := 0 to Length (XML.Child [i].Attrs) - 1
                 do if XML.Child [i].Attrs [j].Name = '' then ReorgForm := htmlspecialchars_decode (XML.Child [i].Attrs [j].Value)
                 else if XML.Child [i].Attrs [j].Name = '' then ReorgINN := htmlspecialchars_decode (XML.Child [i].Attrs [j].Value)
                 else if XML.Child [i].Attrs [j].Name = '' then ReorgINN  := htmlspecialchars_decode (XML.Child [i].Attrs [j].Value)
                 else AddError (Path + ' - :   ' + XML.Child [i].Attrs [j].Name + '   "   () ".');
               end;
         end
    else AddError  (Path + ':      "' + XML.Attrs [i].Name + '"   "   "');
 Result := (Length (Errors) = 0);
end;

constructor TorgIP.Create;
begin
 Init;
end;

destructor TOrgIP.Destroy;
begin
 Init;
 inherited Destroy;
end;

procedure TOrgIP.Init;
begin
 INNPL := '';
 FIO.Free;
 FIO := nil;
 SetLength (Errors,0);
 SetLength (Warnings,0);
end;

procedure TOrgIP.AddError (Msg : ANSIString);
begin
 SetLength (Errors,Length (Errors) + 1);
 Errors [Length (Errors) - 1] := Msg;
end;

procedure TOrgIP.AddWarning (Msg : ANSIString);
begin
 SetLength (Warnings,Length (Warnings) + 1);
 Warnings [Length (Warnings) - 1] := Msg;
end;

function TOrgIP.Read (XML : TXMLElement; Path : ANSIString) : Boolean;
var
 i : integer;
begin
 Init;
 if Length (XML.Attrs) <> 1 then AddError (Path + ':   "   ,   () "     .')
 else if XML.Attrs [0].Name = '' then INNPL := htmlspecialchars_decode (XML.Attrs [0].Value)
 else AddError (Path + ':     ' + XML.Attrs [0].Name);
 if Length (XML.Child) <> 1 then AddError (Path + ':   "   ,   () "      .')
 else if XML.Child [0].Name = ''
  then begin
        FIO := TFIO.Create;
        FIO.Read (XML.Child [0],Path + ' - ');
        if Length (FIO.Errors) > 0 then for i := 0 to Length (FIO.Errors) - 1 do AddError (FIO.Errors [i]);
        if Length (FIO.Warnings) > 0 then for i := 0 to Length (FIO.Warnings) - 1 do AddWarning (FIO.Warnings [i]);
       end
 else AddError (Path + ':      ' + XML.Child [0].Name);
 Result := (Length (Errors) = 0);
end;

constructor TFIO.Create;
begin
 Init;
end;

destructor TFIO.Destroy;
begin
 Init;
 inherited Destroy;
end;

procedure TFIO.AddError (Msg : ANSIString);
begin
 SetLength (Errors,Length (Errors) + 1);
 Errors [Length (Errors) - 1] := Msg;
end;

procedure TFIO.AddWarning (Msg : ANSIString);
begin
 SetLength (Warnings,Length (Warnings) + 1);
 Warnings [Length (Warnings) - 1] := Msg;
end;

procedure TFIO.Init;
begin
 SurName := '';
 Name := '';
 FatherName := '';
 SetLength (Errors,0);
 SetLength (Warnings,0);
end;

function TFIO.Read (XML : TXMLElement; Path : ANSIString) : Boolean;
var
 i : integer;
begin
 Init;
 if Length (XML.Attrs) = 0 then AddError (Path + ':   ", , "   .')
 else for i := 0 to Length (XML.Attrs) - 1
 do if XML.Attrs [i].Name = '' then SurName := htmlspecialchars_decode (XML.Attrs [i].Value)
 else if XML.Attrs [i].Name = '' then Name := htmlspecialchars_decode (XML.Attrs [i].Value)
 else if XML.Attrs [i].Name = '' then FatherName := htmlspecialchars_decode (XML.Attrs [i].Value)
 else AddError (Path + ':     ' + XML.Attrs [i].Name);
 Result := (Length (Errors) = 0);
end;


constructor TSvPred.Create;
begin
 Init;
end;

destructor TSvPred.Destroy;
begin
 Init;
 inherited Destroy;
end;

procedure TSvPred.Init;
begin
 OrgName := '';
 DocName := '';
 SetLength (Errors,0);
 SetLength (Warnings,0);
end;

procedure TSvPred.AddError (Msg : ANSIString);
begin
 SetLength (Errors,Length (Errors) + 1);
 Errors [Length (Errors) - 1] := Msg;
end;

procedure TSvPred.AddWarning (Msg : ANSIString);
begin
 SetLength (Warnings,Length (Warnings) + 1);
 Warnings [Length (Warnings) - 1] := Msg;
end;

function TSvPred.Read (XML : TXMLElement; Path : ANSIString) : Boolean;
var
 i : integer;
begin
 Init;
 if (Length (XML.Attrs) < 1) or (Length (XML.Attrs) > 2) then AddError (Path + ':   "     "      .')
 else for i := 0 to Length (XML.Attrs) - 1
 do if XML.Attrs [i].Name = '' then OrgName := htmlspecialchars_decode (XML.Attrs [i].Value)
 else if XML.Attrs [i].Name = '' then DocName := htmlspecialchars_decode (XML.Attrs [i].Value)
 else AddError (Path + ':   ' + XML.Attrs [i].Name);
 Result := (Length (Errors) = 0);
end;

constructor TPodpisant.Create;
begin
 Init;
end;

destructor TPodpisant.Destroy;
begin
 Init;
 inherited Destroy;
end;

procedure TPodpisant.Init;
begin
 PrPodp := 0;
 FIO.Free;
 SvPred.Free;
 FIO := nil;
 SvPred := nil;
 SetLength (Errors,0);
 SetLength (Warnings,0);
end;

procedure TPodpisant.AddError (Msg : ANSIString);
begin
 SetLength (Errors,Length (Errors) + 1);
 Errors [Length (Errors) - 1] := Msg;
end;

procedure TPodpisant.AddWarning (Msg : ANSIString);
begin
 SetLength (Warnings,Length (Warnings) + 1);
 Warnings [Length (Warnings) - 1] := Msg;
end;

function TPodpisant.Read (XML : TXMLElement; Path : ANSIString) : Boolean;
var
 i,j : integer;
begin
 Init;
 if (Length (XML.Attrs) <> 1) then AddError (Path + ':   "  ,  "     .')
 else for i := 0 to Length (XML.Attrs) - 1
 do if XML.Attrs [i].Name = ''
  then try
        PrPodp := StrToInt (htmlspecialchars_decode (XML.Attrs [i].Value));
       except
        AddError (Path + ':    " ,  ".');
       end
  else AddError (Path + ':   ' + XML.Attrs [i].Name);
 if (Length (XML.Child) > 0)
  then for i := 0 to Length (XML.Child) - 1
   do if XML.Child [i].Name = ''
    then begin
          FIO := TFIO.Create;
          FIO.Read (XML.Child [i],Path + ' - ');
          if Length (FIO.Errors) > 0 then for j := 0 to Length (FIO.Errors) - 1 do AddError (FIO.Errors [j]);
          if Length (FIO.Warnings) > 0 then for j := 0 to Length (FIO.Warnings) - 1 do AddWarning (FIO.Warnings [j]);
         end
   else if XML.Child [i].Name = ''
    then begin
          SvPred := TSvPred.Create;
          SvPred.Read (XML.Child [i],Path + ' - ');
          if Length (SvPred.Errors) > 0 then for j := 0 to Length (SvPred.Errors) - 1 do AddError (SvPred.Errors [j]);
          if Length (SvPred.Warnings) > 0 then for j := 0 to Length (SvPred.Warnings) - 1 do AddWarning (SvPred.Warnings [j]);
         end
     else AddError (Path + ':      ' + XML.Child [i].Name);
 Result := (Length (Errors) = 0);
end;

constructor TSvedPL.Create;
begin
 Init;
end;

destructor TSvedPL.Destroy;
begin
 Init;
 inherited Destroy;
end;

procedure TSvedPL.Init;
begin
 BirthDate := '';
 BirthPlace := '';
 Citizenship := '';
 UdLichn.Free;
 UdLichn := nil;
 AddrRF.Free;
 AddrRF := nil;
 SetLength (Errors,0);
 SetLength (Warnings,0);
end;

procedure TSvedPL.AddError (Msg : ANSIString);
begin
 SetLength (Errors,Length (Errors) + 1);
 Errors [Length (Errors) - 1] := Msg;
end;

procedure TSvedPL.AddWarning (Msg : ANSIString);
begin
 SetLength (Warnings,Length (Warnings) + 1);
 Warnings [Length (Warnings) - 1] := Msg;
end;

function TSvedPL.Read (XML : TXMLElement; Path : ANSIString) : Boolean;
var
 i,j : integer;
begin
 Init;
 if Length (XML.Attrs) = 0
  then AddError (Path + ':   "   ,    "   .')
  else for i := 0 to Length (XML.Attrs) - 1
  do if XML.Attrs [i].Name = '' then BirthDate := htmlspecialchars_decode (XML.Attrs [i].Value)
  else if XML.Attrs [i].Name = '' then BirthPlace := htmlspecialchars_decode (XML.Attrs [i].Value)
  else if XML.Attrs [i].Name = '' then Citizenship := htmlspecialchars_decode (XML.Attrs [i].Value)
  else AddError (Path + ':   - ' + XML.Attrs [i].Name);
 if Length (XML.Child) = 0
  then AddError (Path + ':   "   ,    "    .')
  else for i := 0 to Length (XML.Child) - 1
  do if XML.Child [i].Name = ''
   then begin
         UdLichn := TUdLichn.Create;
         if not UdLichn.Read (XML.Child [i],Path + ' - ')
          then for j := 0 to Length (UdLichn.Errors) - 1
           do AddError (UdLichn.Errors [j]);
        end
  else if XML.Child [i].Name = ''
   then begin
         AddrRF := TAddrRF.Create;
         if not AddrRF.Read (XML.Child [i],Path + '')
          then for j := 0 to Length (AddrRF.Errors) - 1
           do AddError (AddrRF.Errors [j]);
        end
  else AddError (Path + ':    - ' + XML.Child [i].Name);
 Result := (Length (Errors) = 0);
end;

constructor TOrgPL.Create;
begin
 Init;
end;

destructor TOrgPL.Destroy;
begin
 Init;
 inherited Destroy;
end;

procedure TOrgPL.Init;
begin
 SvedPL.Free;
 SvedPL := nil;
 FIO.Free;
 FIO := nil;
 INNFL := '';
end;

procedure TOrgPL.AddError (Msg : ANSIString);
begin
 SetLength (Errors,Length (Errors) + 1);
 Errors [Length (Errors) - 1] := Msg;
end;

procedure TOrgPL.AddWarning (Msg : ANSIString);
begin
 SetLength (Warnings,Length (Warnings) + 1);
 Warnings [Length (Warnings) - 1] := Msg;
end;

function TOrgPL.Read (XML : TXMLElement; Path : ANSIString) : Boolean;
var
 i,j : integer;
begin
 Init;
 if (Length (XML.Attrs) > 0) then AddError (Path + ':   "   -  ,   "    .');
 if (Length (XML.Child) > 0) then AddError (Path + ':   "   -  ,   "    .')
 else for i := 0 to Length (XML.Child) - 1
 do if XML.Child [i].Name = ''
  then begin
        FIO := TFIO.Create;
        FIO.Read (XML.Child [i],Path + ' -  [' + IntToStr (i + 1) + ']');
        if Length (FIO.Errors) > 0 then for j := 0 to Length (FIO.Errors) - 1 do AddError (FIO.Errors [i]);
       end
 else if XML.Child [i].Name = '' then INNFL := htmlspecialchars_decode (trim (XML.Child [i].Value))
 else if XML.Child [i].Name = ''
  then begin
        SvedPL := TSvedPL.Create;
        SvedPL.Read (XML.Child [i],Path + ' -  [' + IntToStr (i + 1) + ']');
        if Length (SvedPL.Errors) > 0 then for j := 0 to Length (SvedPL.Errors) - 1 do AddError (SvedPL.Errors [i]);
       end
 else AddError (Path + ':    : ' + XML.Child [i].Name);
 Result := (Length (Errors) = 0);
end;

end.